#!/bin/sh

MSG="`which gxmessage`" || MSG=xmessage

if ! md5sum -c md5sum.txt
then
	$MSG -geometry 640x160 -center -title "Tkgames Installer" "MD5SUM ERROR: Tkgames has NOT been installed"
	exit 1
fi

FOO=/root/my-roxapps
[ -d $FOO ] || mkdir $FOO

if [ -d "$FOO/Tkgames" ];then
	$MSG -buttons "UnInstall:21,ReInstall:22,Quit" -geometry 640x160 -center -title "Tkgames Installer" "$FOO/Tkgames is already installed"
	case $? in
		21)
			rm -rf "$FOO/Tkgames"
			$MSG -geometry 640x160 -center -title "Tkgames Installer" "Tkgames has been uninstalled"
			exit
		 ;;
		22) true ;;
		*) exit ;;
	esac
fi

rm -rf $FOO/Tkgames/
mv Tkgames/ $FOO/Tkgames/
rox $FOO &

$MSG -geometry 640x160 -center -title "Tkgames Installer" "Tkgames has been installed"




